"""
Django settings for coursemanager2 project.

Generated by 'django-admin startproject' using Django 3.1.5.

For more information on this file, see
https://docs.djangoproject.com/en/3.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.1/ref/settings/
"""
import sys
from datetime import datetime
from distutils import util
import os
from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
from pythonjsonlogger import jsonlogger

BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '^!3lb^4b&hkj-j$g$v8e98_ycn@_bantq52t!b6)e_9tow4u*e'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = bool(util.strtobool(os.environ.get('DEBUG', 'False')))

ALLOWED_HOSTS = os.environ.get('ALLOWED_HOSTS', "").split(";")
USE_X_FORWARDED_HOST = bool(util.strtobool(os.environ.get('USE_X_FORWARDED_HOST', 'False')))


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'rest_framework.authtoken',    # https://github.com/encode/django-rest-framework/issues/6250
    'django.contrib.sites',        # allauth social login and dependency of dj_rest_auth password reset and registration
    'allauth',                     # allauth social login and dependency of dj_rest_auth registration
    'allauth.account',             # allauth social login and dependency of dj_rest_auth registration
    'allauth.socialaccount',       # allauth social login and dependency of dj_rest_auth registration
    'dj_rest_auth',                # enables authentication rest-api and user changes including password-reset
    'dj_rest_auth.registration',   # enables registration rest-api
    'django_crontab',              # used for warm caching lods catalog
    'django_filters',              # easy filtering methods
    'company.apps.CompanyConfig',  # app for companies and company memberships
    'user.apps.UserConfig',        # app that contains user model
    'user_auth.apps.UserAuthConfig',  # app for profile, authentication and registration; uses dj_rest_auth and allauth
    'lods.apps.LodsConfig',        # app for integrating learn on demand systems
    'payed_series.apps.PayedSeriesConfig',  # app for series that companies has payed
    'corsheaders',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'coursemanager2.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [BASE_DIR / 'templates']
        ,
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'coursemanager2.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.1/ref/settings/#databases

DATABASE_ENGINE = os.environ.get("DATABASE_ENGINE", "sqlite3")
if DATABASE_ENGINE == "sqlite3":
    print("Loading sqlite3 database.", file=sys.stderr)
    SQLITE_PATH = BASE_DIR / 'volumes' / 'sqlite3' / 'db.sqlite3'
    # create sqlite path and parents if not exists
    Path(SQLITE_PATH).parent.mkdir(parents=True, exist_ok=True)
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': SQLITE_PATH
        }
    }
elif DATABASE_ENGINE == "postgres":
    print("Loading postgres database.", file=sys.stderr)
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': os.environ.get("POSTGRES_DB"),
            'USER': os.environ.get("POSTGRES_USER"),
            'PASSWORD': os.environ.get("POSTGRES_PASSWORD"),
            'HOST': os.environ.get("POSTGRES_HOST", "localhost"),
            'PORT': 5432,
        }
    }
else:
    raise Exception(f"Wrong DATABASE_ENGINE set: {DATABASE_ENGINE}")


# Password validation
# https://docs.djangoproject.com/en/3.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


REST_FRAMEWORK = {
    'DEFAULT_FILTER_BACKENDS': (
        #'django_filters.rest_framework.DjangoFilterBackend',
        'commons.filter.privacy_filter.PrivacyFilterBackend',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': [
        'rest_framework.authentication.BasicAuthentication',
        'rest_framework.authentication.SessionAuthentication',
        'rest_framework.authentication.TokenAuthentication',
    ]
}


class CustomJsonFormatter(jsonlogger.JsonFormatter):
    def add_fields(self, log_record, record, message_dict):
        super(CustomJsonFormatter, self).add_fields(log_record, record, message_dict)
        if not log_record.get('timestamp'):
            # this doesn't use record.created, so it is slightly off
            now = datetime.utcnow().strftime('%Y-%m-%dT%H:%M:%S.%fZ')
            log_record['timestamp'] = now
        if log_record.get('level'):
            log_record['level'] = log_record['level'].upper()
        else:
            log_record['level'] = record.levelname
        log_record.setdefault('name', record.name)
        log_record.setdefault('pathname', record.pathname)
        log_record.setdefault('module', record.module)
        log_record.setdefault('filename', record.filename)
        log_record.setdefault('lineno', record.lineno)
        log_record.setdefault('funcName', record.funcName)
        log_record.setdefault('args', record.args)


LOGGING_METHOD = os.environ.get('LOGGING_METHOD', 'cron')
DEBUG_LEVEL = "DEBUG"

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
            'formatter': LOGGING_METHOD,
            'stream': sys.stderr
        },
    },
    "formatters": {
        'cron': {
            'format': '{message}',
            'style': '{'
        },
        'small': {
            'format': '[{pathname}:{funcName}:{lineno:d}] {message}',
            'style': '{'
        },
        'standard': {
            'format': '[%(levelname)s][%(asctime)s][%(filename)s][%(funcName)s][%(lineno)d] > %(message)s',
        },
        "json": {
            "()": CustomJsonFormatter
        }
    },
    'loggers': {
        'django': {
            'handlers': ['console'],
            'level': 'ERROR',
        },
        'asyncio': {
            'handlers': ['console'],
            'level': 'ERROR',
        },
        'rules': {
            'handlers': ['console'],
            'level': 'ERROR',
        },
        'urllib3': {
            'handlers': ['console'],
            'level': 'ERROR',
        },
    },
    'root': {
        'handlers': ['console'],
        'level': DEBUG_LEVEL,
    },
}

# Internationalization
# https://docs.djangoproject.com/en/3.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.1/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, "static")
MEDIA_ROOT = os.path.join(BASE_DIR, "media")

# Mail
EMAIL_USE_TLS = bool(util.strtobool(os.environ.get('EMAIL_USE_TLS', 'True')))
EMAIL_HOST = os.environ.get('EMAIL_HOST', None)
EMAIL_PORT = int(os.environ.get('EMAIL_PORT', '587'))
EMAIL_HOST_PASSWORD = os.environ.get('EMAIL_HOST_PASSWORD', None)
EMAIL_HOST_USER = os.environ.get('EMAIL_HOST_USER', None)
DEFAULT_FROM_EMAIL = os.environ.get('DEFAULT_FROM_EMAIL', "Django App")

# custom user model
AUTH_USER_MODEL = 'user.User'

# redirect after authentication
LOGIN_REDIRECT_URL = '/api/'
ACCOUNT_LOGOUT_REDIRECT_URL = '/api/'

# authentication
SITE_ID = 1
ACCOUNT_AUTHENTICATION_METHOD = 'email'
ACCOUNT_EMAIL_REQUIRED = True
ACCOUNT_UNIQUE_EMAIL = True
ACCOUNT_USER_MODEL_USERNAME_FIELD = None
ACCOUNT_USERNAME_REQUIRED = False
ACCOUNT_EMAIL_VERIFICATION = os.environ.get('ACCOUNT_EMAIL_VERIFICATION', 'optional')
REST_AUTH_SERIALIZERS = {
    'LOGIN_SERIALIZER': 'user_auth.serializers.CustomLoginSerializer',
}
REST_AUTH_REGISTER_SERIALIZERS = {
    'REGISTER_SERIALIZER': 'user_auth.serializers.CustomRegisterSerializer',
}

# lods
LODS_API_KEY = os.environ.get('LODS_API_KEY')
LODS_API_URL = os.environ.get('LODS_API_URL', 'https://labondemand.com/api/v3/{method}')

# cronjobs
ENABLE_CRON_PIPE = bool(util.strtobool(os.environ.get('ENABLE_CRON_PIPE', 'True')))
CRON_PIPE = os.environ.get('CRON_PIPE', "2>&1 | /usr/bin/logger -t django-cron-coursemanager2")
if not ENABLE_CRON_PIPE:
    CRON_PIPE = None
CATALOG_UPDATE_CRONTAB = '*/1 * * * *'
CRONJOBS = [
    (CATALOG_UPDATE_CRONTAB, 'lods.cron.catalog_updater.update_catalog_job', CRON_PIPE)
]

# CORS
# TODO: irgendwann durch urls ersetzen
CORS_ALLOW_ALL_ORIGINS = True